-- http://allaboutfpga.com/vhdl-testbench-tutorial/
-- Uppsala University - Digital Electronics Design with VHDL, 1FA326
-- Copyright (c) 2020 Henrik Alfken <henke.uu.se@inbox.lv>
library ieee;
use ieee.std_logic_1164.all;

entity TBupDwnCountr is end TBupDwnCountr;  -- Closed system.
architecture rtl of TBupDwnCountr is
  constant clkPeriod : time := 2 ns;
  signal CLK    : std_logic := '0';
  signal Rst    : std_logic := '0';
  signal Up     : std_logic := '0';
  signal Countr : std_logic_vector(3 downto 0);
  component upDwnCountr port (
    clock   : in std_logic;
    reset   : in std_logic;
    up      : in std_logic;
    counter :out std_logic_vector(3 downto 0));
  end component;
begin -- Instantiate the Unit Under Test:
  unitUnderTest : upDwnCountr port map (
    clock   => CLK,
    reset   => Rst,
    up      => Up,
    counter => Countr
  );  -- End of port map.
  clockProcess : process begin
    CLK <= '0';
    wait for clkPeriod/2;
    CLK <= '1';
    wait for clkPeriod/2;
  end process clockProcess;
  stimulusProcess : process begin
    Rst <= '1';
    wait for clkPeriod;
    Rst <= '0';
    Up <= '1';
    wait for clkPeriod*16;
    Up <= '0';
    wait;
  end process stimulusProcess;
end rtl;
